﻿Imports System.IO
Imports System.Windows.Forms
Imports System.IO.Ports
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Public Class Form1
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' read a .png or a .jpg or a .bmp file and stores RGBA to a file
        ' format is 32 bytes at the beginning then data. 4 bytes per pixel
        ' long 1 = size in bytes
        ' long 2 = width
        ' long 3 = height
        Dim Mycolor As Color
        Dim x, y, t, i As Integer
        Dim sizex, sizey As Integer
        Dim Sizefile As Long
        Dim Filepath, Sourcefile, DestinationFile As String
        Filepath = TextBox1.Text ' directory
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.png;*.jpg;*.bmp" ' select .png and .jpg and .bmp icon files
        OpenFileDialog1.ShowDialog() ' open the openfile dialog
        Sourcefile = OpenFileDialog1.FileName ' get the filename
        Sourcefile = Strings.Mid(Sourcefile, Strings.Len(Filepath) + 2) ' strip off directory
        ' load in the picture
        ' this little bit of code replaces new sytem.drawing.bitmap as the latter leaves the file locked eg so paintshop can't save a new file
        Dim img As Image
        Dim fs As New FileStream(Filepath + "\" + Sourcefile, IO.FileMode.Open) ' open the picture
        img = Image.FromStream(fs) ' load in the file
        fs.Close() ' close the picture
        PictureBox1.Image = img ' display the picture
        sizex = PictureBox1.Image.Width - 1 ' get the width minus 1
        sizey = PictureBox1.Image.Height - 1 ' get the height minus 1
        Dim PixelArray(sizex, sizey, 5) As Byte ' define an array to store the pixel values
        PictureBox1.Width = PictureBox1.Image.Width ' set to actual size
        PictureBox1.Height = PictureBox1.Image.Height ' set to actual size
        PictureBox2.Width = PictureBox1.Image.Width ' set alpha display to actual size
        PictureBox2.Height = PictureBox1.Image.Height ' set alpha display to actual size
        ' picture to array
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox1.Image) 'image from picture box
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = MyBitmap.GetPixel(x, y) ' get the color
                PixelArray(x, y, 0) = Mycolor.R ' red
                PixelArray(x, y, 1) = Mycolor.G ' green
                PixelArray(x, y, 2) = Mycolor.B ' blue
                PixelArray(x, y, 3) = Mycolor.A ' transparency value 0-255 (255 for normal pictures = fully opaque)
            Next
        Next
        'display alpha on a separate picturebox - usually an outline of the icon with rounded corners
        For y = 0 To sizey
            For x = 0 To sizex
                Mycolor = Color.FromArgb(255, PixelArray(x, y, 3), PixelArray(x, y, 3), PixelArray(x, y, 3))
                MyBitmap.SetPixel(x, y, Mycolor) ' set the pixels back to this palette color
            Next x
        Next y
        PictureBox2.Image = MyBitmap ' display the picture after processing
        Sizefile = ((sizex + 1) * (sizey + 1)) * 4
        Dim OutputArray(Sizefile) As Byte ' 4 bytes per pixel ARGB plus 32 byte header
        t = 0 ' start data 
        For y = 0 To sizey
            For x = 0 To sizex
                For i = 0 To 3
                    OutputArray(t) = PixelArray(x, y, i)
                    t += 1
                Next i
            Next
        Next
        DestinationFile = Strings.Left(Sourcefile, Strings.Len(Sourcefile) - 4) + ".icn" ' use a rgb extension
        Dim OutputILI As New FileStream(Filepath + "\" + DestinationFile, FileMode.Create, FileAccess.Write)
        OutputILI.Write(OutputArray, 0, Sizefile) ' save bytes
        OutputILI.Close()
        Label5.Visible = True
        Label5.Text = "Created: " + DestinationFile
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Filepath, Sourcefile, DestinationFile, pngfile As String
        Filepath = TextBox2.Text ' directory
        OpenFileDialog1.Multiselect = False
        OpenFileDialog1.InitialDirectory = Filepath
        OpenFileDialog1.FileName = "*.fnt" ' select .fnt file. 
        OpenFileDialog1.ShowDialog() ' open the openfile dialog
        Sourcefile = OpenFileDialog1.FileName ' get the filename
        Sourcefile = Strings.Mid(Sourcefile, Strings.Len(Filepath) + 2) ' strip off directory
        pngfile = Strings.Left(Sourcefile, Strings.Len(Sourcefile) - 4) + "_0.png"
        Dim img As Image
        Dim fs As New FileStream(Filepath + "\" + pngfile, IO.FileMode.Open) ' open the picture
        img = Image.FromStream(fs) ' load in the file
        fs.Close() ' close the picture
        PictureBox3.Image = img ' display the picture
        RichTextBox1.LoadFile(Filepath + "\" + Sourcefile, RichTextBoxStreamType.PlainText)
        TextBox3.Text = Sourcefile
        TextBox4.Text = Strings.Left(Sourcefile, Strings.Len(Sourcefile) - 4) + ".ifn"
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'Dim mycolor As Color
        ColorDialog1.ShowDialog()
        PictureBox4.BackColor = ColorDialog1.Color
        'mycolor = PictureBox4.BackColor
        'mycolor.R, mycolor.G, mycolor.B
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'Dim mycolor As Color
        ColorDialog1.ShowDialog()
        PictureBox5.BackColor = ColorDialog1.Color

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim FontArray(262144) As Byte ' won't need all of this!
        Dim Ascii, x, y, i, j, Width, Height, Xoffset, Yoffset, Xadvance, Fontvalue As Long
        Dim RedDiff, GreenDiff, BlueDiff, Backred, BackGreen, BackBlue, ForeRed, ForeGreen, ForeBlue As Single
        Dim ILIred, ILIgreen, ILIblue As Single
        Dim ILIredbyte, ILIgreenbyte, ILIbluebyte As Long
        Dim ILIlong As Long
        Dim ILIhigh, ILIlow As Byte
        Dim Mycolor As Color
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox3.Image) 'image from picture box
        Dim LineOfText As String
        Dim Counter, StartCharacter As Long
        Dim Header As String
        Dim FontHeight As Byte
        Dim start1, start2, finish1, finish2, loopstep1, loopstep2 As Long
        Backred = PictureBox5.BackColor.R
        BackGreen = PictureBox5.BackColor.G
        BackBlue = PictureBox5.BackColor.B
        ForeRed = PictureBox4.BackColor.R
        ForeGreen = PictureBox4.BackColor.G
        ForeBlue = PictureBox4.BackColor.B
        RedDiff = Backred - ForeRed
        GreenDiff = BackGreen - ForeGreen
        BlueDiff = BackBlue - ForeBlue
        Counter = 256 + 1024 ' first 256 bytes are data about the font - size, bold, back and foreground colors etc and the next 1024 are the jump tables
        StartCharacter = Counter
        Header = "Portrait  "
        Header += "Forecolor" + Strings.Chr(ForeRed) + Strings.Chr(ForeGreen) + Strings.Chr(ForeBlue)
        Header += "Backcolor" + Strings.Chr(Backred) + Strings.Chr(BackGreen) + Strings.Chr(BackBlue)
        For Each Line As String In RichTextBox1.Lines ' much faster than for i=0 to richtextbox1.lines.length
            LineOfText = Line
            If Strings.Left(LineOfText, 4) = "info" Then
                Header += LineOfText ' add this line to header string
            End If
            If Strings.Left(LineOfText, 6) = "common" Then
                FontHeight = Strings.Val(Strings.Mid(LineOfText, 19, 2))
            End If
            If Strings.Left(LineOfText, 7) = "char id" Then
                'char id=32   x=96    y=21    width=1     height=1     xoffset=0     yoffset=23    xadvance=7     page=0  chnl=15
                Ascii = Strings.Val(Strings.Mid(LineOfText, 9, 3)) ' sub 17 
                x = Strings.Val(Strings.Mid(LineOfText, 16, 3))
                y = Strings.Val(Strings.Mid(LineOfText, 24, 3))
                Width = Strings.Val(Strings.Mid(LineOfText, 36, 3))
                Height = Strings.Val(Strings.Mid(LineOfText, 49, 3))
                Xoffset = Strings.Val(Strings.Mid(LineOfText, 63, 3))
                Yoffset = Strings.Val(Strings.Mid(LineOfText, 77, 3))
                Xadvance = Strings.Val(Strings.Mid(LineOfText, 92, 3))
                StartCharacter = Counter ' start of the data about this character
                LongtoArray(FontArray, (Ascii * 4 + 256), StartCharacter) ' 4 byte jump table
                LongtoArray(FontArray, StartCharacter, Width * Height) ' size of the character
                LongtoArray(FontArray, StartCharacter + 4, Width) ' width
                LongtoArray(FontArray, StartCharacter + 8, Height) ' height
                LongtoArray(FontArray, StartCharacter + 12, Xoffset) ' xoffset
                LongtoArray(FontArray, StartCharacter + 16, Yoffset) ' yoffset
                LongtoArray(FontArray, StartCharacter + 20, Xadvance) 'xadvance

                Counter += 32 ' start of the pixels - add 32
                start1 = y ' outside loop
                start2 = x ' inside loop
                finish1 = y + Height - 1
                finish2 = x + Width - 1
                loopstep1 = 1 ' add 1 to each step
                loopstep2 = 1
                For j = start1 To finish1 Step loopstep1
                    For i = start2 To finish2 Step loopstep2
                        'If RadioButton1.Checked = True Then
                        Mycolor = MyBitmap.GetPixel(i, j) ' get the color
                        'Else
                        'Mycolor = MyBitmap.GetPixel(j, i) ' swap i and j if in landscape mode
                        'End If
                        Fontvalue = Mycolor.R ' grayscale so RGB should be the same
                        ILIred = Backred - (RedDiff * Fontvalue) / 255
                        ILIgreen = BackGreen - (GreenDiff * Fontvalue) / 255
                        ILIblue = BackBlue - (BlueDiff * Fontvalue) / 255
                        If ILIred > 255 Then ILIred = 255 ' limit testing
                        If ILIred < 0 Then ILIred = 0
                        If ILIgreen > 255 Then ILIgreen = 255
                        If ILIgreen < 0 Then ILIgreen = 0
                        If ILIblue > 255 Then ILIblue = 255
                        If ILIblue < 0 Then ILIblue = 0
                        ILIredbyte = CByte(ILIred)
                        ILIgreenbyte = CByte(ILIgreen)
                        ILIbluebyte = CByte(ILIblue)
                        ILIredbyte = ILIredbyte >> 3 ' round down 3 places
                        ILIgreenbyte = ILIgreenbyte >> 2  ' round down two places
                        ILIbluebyte = ILIbluebyte >> 3 ' round down 3 places
                        ILIlong = (ILIredbyte << 11) + (ILIgreenbyte << 5) + ILIbluebyte
                        ILIhigh = HighByte(ILIlong) ' get high and low bytes
                        ILIlow = LowByte(ILIlong)
                        FontArray(Counter) = ILIlow ' store the pixels
                        FontArray(Counter + 1) = ILIhigh
                        Counter += 2
                    Next
                Next
                Counter += 4 ' so last pixel included ** this doesn't work, not sure why, file looks ok in hexedit **
                Counter = Counter And &HFFFFFFFC ' mask off lower 2 bits, same as rounding to the nearest long so data is long aligned
            End If
        Next
        ' store the size of the array at the beginning of the array
        ' because it is much easier to read in blocks of 256 bytes, round up
        Counter = Counter + 256 ' round up by one block
        Counter = Counter And &HFFFFFF00 ' mask off lower 256 - same as rounding up
        LongtoArray(FontArray, 0, Counter) ' add counter to array at location 0 (file length)
        ' put in the header string
        For i = 1 To Strings.Len(Header)
            FontArray(i + 3) = Strings.Asc(Strings.Mid(Header, i, 1))
        Next
        ' Store a byte for the height in a fixed location - easier to decode
        For i = 1 To 6
            FontArray(i + 244) = Strings.Asc(Strings.Mid("Height", i, 1)) ' so can see the start of the jump table
        Next
        FontArray(251) = FontHeight
        ' store some text
        For i = 1 To 4
            FontArray(i + 251) = Strings.Asc(Strings.Mid("Jump", i, 1)) ' so can see the start of the jump table
        Next
        Dim DestinationFile As String
        DestinationFile = TextBox2.Text + "\" + TextBox4.Text
        Dim OutputILI As New FileStream(DestinationFile, FileMode.Create, FileAccess.Write)
        OutputILI.Write(FontArray, 0, Counter) ' save bytes
        OutputILI.Close()
        MsgBox("Finished")
    End Sub
    Private Sub LongtoArray(ByVal Fontarray() As Byte, ByVal Address As Long, ByVal Value As Long)
        ' adds 4 bytes to the fontarray, LSB first, for signed values for the propeller
        ' -1 converts to FFFFFFFF
        Dim Hexstring As String
        Hexstring = Strings.Right("00000000" + Strings.Hex(Value), 8)
        Fontarray(Address) = Strings.Val("&H" + Strings.Mid(Hexstring, 7, 2))
        Fontarray(Address + 1) = Strings.Val("&H" + Strings.Mid(Hexstring, 5, 2))
        Fontarray(Address + 2) = Strings.Val("&H" + Strings.Mid(Hexstring, 3, 2))
        Fontarray(Address + 3) = Strings.Val("&H" + Strings.Mid(Hexstring, 1, 2))
    End Sub


    Private Function HighByte(ByVal value As Long) As Byte
        value = value And &HFFFF ' mask to a word
        HighByte = value >> 8
    End Function
    Private Function LowByte(ByVal value As Long) As Byte
        LowByte = value And 255 ' mask to a byte
    End Function

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim LineOfText As String
        Dim ascii As Integer
        Dim ReadingData As Boolean = False
        Dim BitmapLine As Byte
        Dim row As Integer
        Dim bitvalue As Byte
        Dim Bboxx, Bboxy, Bboxxoffset, Bboxyoffset, top As Integer
        Dim x, y, width, height, xoffset, yoffset, xadvance As Integer
        Dim Buildstring As String
        RichTextBox1.Clear()
        RichTextBox1.Text += "info face='4x6' size=6 bold=0 italic=0 charset='' unicode=1 stretchH=100 smooth=1 aa=1 padding=0,0,0,0 spacing=1,1 outline=0" + vbCrLf
        RichTextBox1.Text += "common lineHeight=6 base=32 scaleW=256 scaleH=256 pages=1 packed=0 alphaChnl=1 redChnl=0 greenChnl=0 blueChnl=0" + vbCrLf
        RichTextBox1.Text += "page id=0 file='4x6'" + vbCrLf
        RichTextBox1.Text += "chars count = 95" + vbCrLf
        RichTextBox2.LoadFile("c:\propeller\ili9325\fonts\4x6.bdf", RichTextBoxStreamType.PlainText)
        ' picture box
        Dim img As Image
        Dim fs As New FileStream("c:\propeller\ili9325\fonts\blank.bmp", IO.FileMode.Open) ' open the picture
        img = Image.FromStream(fs) ' load in the blank picture
        fs.Close() ' close the picture
        PictureBox3.Image = img ' display the picture
        Dim MyBitmap As New System.Drawing.Bitmap(PictureBox3.Image) 'image from picture box
        'MyBitmap.SetPixel(10, 10, System.Drawing.Color.White) ' change a pixel in array
        For Each Line As String In RichTextBox2.Lines ' much faster than for i=0 to richtextbox1.lines.length
            LineOfText = Line
            If Strings.Left(LineOfText, 8) = "ENCODING" Then
                ascii = Strings.Val(Strings.Mid(LineOfText, 10))
                If ascii >= 32 And ascii < 127 Then
                    Buildstring = "char id=" + Strings.Trim(Strings.Str(ascii)) + "      "
                    Buildstring = Strings.Left(Buildstring, 13)
                    Buildstring += "x=" + Strings.Trim(Strings.Str(x)) + "        "
                    Buildstring = Strings.Left(Buildstring, 21)
                    Buildstring += "y=" + Strings.Trim(Strings.Str(y)) + "        "
                    Buildstring = Strings.Left(Buildstring, 29)
                    Buildstring += "width=4     height=6     xoffset=0     yoffset=0     xadvance=4     page=0  chnl=15"
                    RichTextBox1.Text += Buildstring + vbCrLf
                End If
            End If
            If Strings.Left(LineOfText, 7) = "ENDCHAR" Then
                ReadingData = False
                x += 4
                If x > 128 Then
                    x = 0
                    y += 6
                End If
            End If
            If ReadingData = True And ascii >= 32 And ascii < 127 Then
                BitmapLine = Strings.Val("&H" + LineOfText) ' first 4 bits as this is a 4x6 file
                ' uses row
                For i = 0 To 3
                    bitvalue = BitmapLine And 128 ' logical or
                    bitvalue = bitvalue >> 7 ' 10000000 to 00000001
                    If bitvalue = 1 Then
                        MyBitmap.SetPixel(x + i + Bboxxoffset, y + row, System.Drawing.Color.White)
                    End If
                    BitmapLine = BitmapLine << 1 ' bit shift
                Next
                row += 1 ' next row
            End If
            If Strings.Left(LineOfText, 6) = "BITMAP" Then
                ReadingData = True
            End If
            If Strings.Left(LineOfText, 3) = "BBX" Then
                Bboxx = Strings.Val(Strings.Mid(LineOfText, 5, 1))
                Bboxy = Strings.Val(Strings.Mid(LineOfText, 7, 1))
                Bboxxoffset = Strings.Val(Strings.Mid(LineOfText, 9, 1))
                Bboxyoffset = Strings.Val(Strings.Mid(LineOfText, 11))
                ' the baseline is a p and q which are -1
                ' p = 3,5,0,-1   = starts -1 and is 5 high so starts at 4
                ' a = 3,4,0,0 =  starts 0 and is 4 high so starts at 4
                ' b = 3,5,0,0
                ' j = 3 6 0 -1
                top = Bboxyoffset + Bboxy ' top of the character
                row = 5 - top ' start row
            End If
        Next
        PictureBox3.Image = MyBitmap ' save back to the picture
        TextBox4.Text = "4x6.ifn"
    End Sub


End Class
